%%Parametros por defecto de las LVQ
epochs         = 150;
goal           = 0.01;
show           = Inf;
showWindow     = false;
hidden_neurons = 10; %%pruebas con 5, 3, 8

warning off;

%%===============================================================================
%%ClusterLVQ Mean and StdDev AdaBoost
Times           = 1;
l_rate   = [0.001 0.01 0.05 0.1 0.5 0.8];
l_function=['learnlv1' 'learnlv2'];

% Sum_Accuracy    = 0;
% Sum_Specificity = 0;
% Sum_Sensitivity = 0;

fi = fopen('/home/maite/Documentos/IWANN_IWINAC_IDEAL2009/resultados/AdaBoost_LVQ1_LVQ2_MeanStdDev/resultados_AdaBoost_LVQ1_LVQ2_MediasDesviaciones.txt', 'w');

for l_function = 1:2
    learning_function=int2str(l_function);
    
    lf = strcat('learnlv', learning_function)
    
    for learning_rate = l_rate
        learning_rate

        for times=1:Times;
           [Accuracy Specificity Sensitivity alpha weakres] = ClusterLVQ_AdaBoost (learning_rate, lf, hidden_neurons);
%            Sum_Accuracy    = Sum_Accuracy    + Accuracy;
%            Sum_Specificity = Sum_Specificity + Specificity;
%            Sum_Sensitivity = Sum_Sensitivity + Sensitivity;
        end;

%         Mean_Accuracy    = Sum_Accuracy    /Times;
%         Mean_Specificity = Sum_Specificity /Times;
%         Mean_Sensitivity = Sum_Sensitivity /Times;
        
        nombre=strcat('/home/maite/Documentos/IWANN_IWINAC_IDEAL2009/resultados/AdaBoost_LVQ1_LVQ2_MeanStdDev/AdaBoost', '_', lf, '_', 'hidden_neurons', num2str(hidden_neurons), '_', 'LearningRate', '_', num2str(learning_rate), '_', 'Times', '_', int2str(Times));
        Medidas = [Accuracy Specificity Sensitivity];   
        save(nombre, 'Accuracy', 'Specificity', 'Sensitivity', 'alpha', 'weakres', 'learning_function', 'learning_rate', 'Times', 'nombre');
        fprintf(fi, '%s %d %d %6.3f %6.3f   %s %6.3f %s %6.3f %s %6.3f', lf, hidden_neurons, epochs, goal, learning_rate, 'Acc=', Accuracy, 'Spec=', Specificity, 'Sens=', Sensitivity);
        fprintf(fi, '\n');
    end
end
fclose(fi);

%%===============================================================================
%%ClusterLVQ Voxel Intensities AdaBoost
epochs         = 150;
goal           = 0.01;
show           = Inf;
showWindow     = false;
hidden_neurons = 5;

warning off;


Times           = 1;
l_rate          = [0.001 0.01 0.05 0.1 0.5 0.8];
l_function      = ['learnlv1' 'learnlv2'];

% Sum_Accuracy    = 0;
% Sum_Specificity = 0;
% Sum_Sensitivity = 0;

fi = fopen('/Users/Maite/Desktop/IWANN_IWINAC_IDEAL2009/resultados/AdaBoost_LVQ1_LVQ2_Intensidades/resultados_AdaBoost_LVQ1_LVQ2_MediasDesviaciones.txt', 'w');

for l_function = 1:2
    learning_function=int2str(l_function);
    
    lf = strcat('learnlv', learning_function)
    
    for learning_rate = l_rate
        learning_rate

        for times=1:Times;
           [Accuracy Specificity Sensitivity alpha weakres] = ClusterLVQ_AdaBoost_Intensities (learning_rate, lf, hidden_neurons);

        end;
        
        nombre=strcat('/Users/Maite/Desktop/IWANN_IWINAC_IDEAL2009/resultados/AdaBoost_LVQ1_LVQ2_Intensidades/AdaBoost', '_', lf, '_', 'hidden_neurons', hidden_neurons, '_', 'LearningRate', '_', num2str(learning_rate), '_', 'Times', '_', int2str(Times));
        Medidas = [Accuracy Specificity Sensitivity];   
        save(nombre, 'Accuracy', 'Specificity', 'Sensitivity', 'alpha', 'weakres', 'learning_function', 'learning_rate', 'Times', 'nombre');
        fprintf(fi, '%s %d %d %6.3f %6.3f   %s %6.3f %s %6.3f %s %6.3f', lf, hidden_neurons, epochs, goal, learning_rate, 'Acc=', Accuracy, 'Spec=', Specificity, 'Sens=', Sensitivity);
        fprintf(fi, '\n');
    end
end
fclose(fi);



%%===============================================================================
%%Diverse AdaBoost_LVQ_Intensities
hidden_neurons_min  = 5; 
hidden_neurons_max  = 20; %probado con 10
hidden_neurons_step = 1;
  
min_diversity   = 0.5;


fi = fopen('/home/maite/Documentos/IWANN_IWINAC_IDEAL2009/resultados/DivAdaBoost_LVQ1_LVQ2_Intensidades/resultados_DiverseAdaBoost_LVQ1_LVQ2_Intensidades.txt', 'w');
warning off;

Times = 1;
%%Parametros por defecto de las LVQ
epochs         = 150;
goal           = 0.01;
show           = Inf;
showWindow     = false;
learning_rate  = 0.01;

l_function=['learnlv1' 'learnlv2'];

for l_function = 1:2
    
    lf=strcat('learnlv', int2str(l_function))

    for times=1:Times;
        [Accuracy Specificity Sensitivity] = Diverse_AdaBoost_LVQ_VoxelIntensities (lf);
   
    end;

        nombre=strcat('/home/maite/Documentos/IWANN_IWINAC_IDEAL2009/resultados/DivAdaBoost_LVQ1_LVQ2_Intensidades/AdaBoost', '_', lf, '_', 'Times', '_', int2str(Times));
        Medidas = [Accuracy Specificity Sensitivity];   
        save(nombre);
        fprintf(fi, '%s %6.3f %d %6.3f  %s %6.3f %s %6.3f %s %6.3f', lf, learning_rate, epochs, goal, 'Acc=', Accuracy, 'Spec=', Specificity, 'Sens=', Sensitivity);
        fprintf(fi, '\n');
end
fclose(fi);


%%===============================================================================
%%Diverse AdaBoost_LVQ_MeanAndStdDev
hidden_neurons_min  = 5; 
hidden_neurons_max  = 20; %probado con 20,10
hidden_neurons_step = 1;
  
min_diversity   = 0.5;


fi = fopen('/home/maite/Documentos/IWANN_IWINAC_IDEAL2009/resultados/DivAdaBoost_LVQ1_LVQ2_MeanStdDev/resultados_DiverseAdaBoost_LVQ1_LVQ2_MeanStdDev.txt', 'w');
warning off;

Times = 1;
%%Parametros por defecto de las LVQ
epochs         = 150;
goal           = 0.01;
show           = Inf;
showWindow     = false;
learning_rate  = 0.01; %%0.01

l_function=['learnlv1' 'learnlv2'];

for l_function = 1:2
    
    lf=strcat('learnlv', int2str(l_function))

    for times=1:Times;
        [Accuracy Specificity Sensitivity] = Diverse_AdaBoost_LVQ_MeanAndStdDev (lf);
   
    end;

        nombre=strcat('/home/maite/Documentos/IWANN_IWINAC_IDEAL2009/resultados/DivAdaBoost_LVQ1_LVQ2_MeanStdDev/AdaBoost', '_', lf, '_', 'Times', '_', int2str(Times));
        Medidas = [Accuracy Specificity Sensitivity];   
        save(nombre);
        fprintf(fi, '%s %6.3f %d %6.3f  %s %6.3f %s %6.3f %s %6.3f', lf, learning_rate, epochs, goal, 'Acc=', Accuracy, 'Spec=', Specificity, 'Sens=', Sensitivity);
        fprintf(fi, '\n');
end
fclose(fi);
