function [Accuracy Specificity Sensitivity] = SVMVoting (data_controles, data_pacientes)

%cd /media/xcraft/Documents/phd/medical_images/my_papers/IWANN09/src

load ../Female/spm/spm_segmented_oasis_females.mat

[C P] = extractMeanAndStdDevFromEachCluster (female_crystal_brain_cov0, data_controles, data_pacientes);
%[C P] = extractVoxelIntensitiesFromEachCluster (female_crystal_brain_cov0, CONTROLES, PACIENTES);

[L, num_clusters] = bwlabeln (female_crystal_brain_cov0);

k_de_kfold = 10;
p = cvpartition(size(C,1),'kfold',k_de_kfold);
total_tests = 0;
TP = 0;
TN = 0;
FP = 0;
FN = 0;

for k=1:k_de_kfold;

   C_training = C(training (p,k) == 1,:,:);
   P_training = P(training (p,k) == 1,:,:);
   C_test     = C(training (p,k) == 0,:,:);
   P_test     = P(training (p,k) == 0,:,:);
   total_results (k) = 0;

   for i=1:num_clusters;
      %training
      [training_data(i).data, training_data(i).label] = alignAndLabelData (C_training(:,i ,:), P_training(:,i ,:));
      models(i) = svmtrain (training_data(i).label, training_data(i).data, '-s 2 -t 0'); %'-t 2 -g 0.031');

      %classification
      [test_data(i).data, test_data(i).label] = alignAndLabelData (C_test(:,i ,:), P_test(:,i ,:));
      [results(k,i).predict_label, results(k,i).accuracy, results(k,i).prob_estimates] = svmpredict (test_data(i).label, test_data(i).data, models(i));
   end;

   for s=1:size(test_data(1).data,1);

      %voting from sum of all the results of each cluster SVM, 
      %if negative: class = -1
      %else if positive: class = 1
      %else if zero: only first cluster SVM prediction will be taken into account
      class = 0;
      for c=1:num_clusters;
         class = class + results (k,c).predict_label(s);
      end;
      if (class == 0);
         class = results (k,1).predict_label(s);
      end;

      sum_class = class
      subj_predictions(s) = sign(class)

      %counting and compare with target label
      target_label = test_data(1).label(s)

      if (test_data(1).label(s) == -1); %positive
         if   (subj_predictions(s) == -1); TP = TP + 1;
         else                              FN = FN + 1;
         end;
      else %negative
         if   (subj_predictions(s) ==  1); TN = TN + 1;
         else                              FP = FP + 1;
         end;
      end;

      total_tests = total_tests + 1;

   end;

%   predictions(k,:) = subj_predictions(:);

   clear subj_predictions;

end;
Accuracy    = (TP + TN) / total_tests
Specificity = TN / (TN+FP)
Sensitivity = TP / (TP+FN)


