function [TP TN FP FN Accuracy Specificity Sensitivity] = computeErrors (target, output)

   if (size(target) ~= size(output))
      'target and output vectors size must be the same'
      exit
   end

   TP=0;
   TN=0;
   FP=0;
   FN=0;

   positive_value = min(target);
   negative_value = max(target);
   tests_no       = size(target,2);

   for i=1:tests_no

      if (target(i) == positive_value) %positive
         if (output(i) == positive_value) TP = TP + 1;
         else                             FN = FN + 1;
         end

      else %negative
         if (output(i) == negative_value) TN = TN + 1;
         else                             FP = FP + 1;
         end
      end

   end

   Accuracy    = (TP + TN) / tests_no;
   Specificity = TN / (TN+FP);
   Sensitivity = TP / (TP+FN);
