[%% GM matter proportion for each crystal brain cluster
function [C P] = extractGMProportionFromEachCluster (crystal_brain, controls, patients)

   [L, num_clusters] = bwlabeln (crystal_brain);

   for k = 1:num_clusters; 
       cluster_size (k) = sum(sum(sum(L==k)));
   end;

   %FOR OASIS original subjects
   for i = 1:size(controls,1); 
       subj = controls(i,:,:,:);
       for k = 1:num_clusters; 
           C(i,k) = sum ( sum ( sum (double(subj(L==k)) > 0))) / cluster_size(k);
       end; 
   end;

   for i = 1:size(patients,1); 
       subj = patients(i,:,:,:);
       for k = 1:num_clusters; 
           P(i,k) = sum ( sum ( sum (double(subj(L==k)) > 0))) / cluster_size(k);
       end;
   end;

