%%oasis csv info
[csv_header csv_info] = oasis_read_csv ('oasis_cross-sectional.csv');

%%controles
cd '/opt/IWANN09/Female/original'
lst = dir('control*hdr'); 
for i=1:size(lst,1);
    info=analyze75info(lst(i).name); 
    CONTROLES(i,:,:,:) = analyze75read(info);
    controles_info (i,:) = lst(i).name (9:21);
end;

%imshow (reshape(PACIENTES(1,60,:,:),91, 91), [min(min(PACIENTES(1,60,:,:))) max(max(PACIENTES(1,60,:,:)))])

%%pacientes
cd '/opt/IWANN09/Female/original'
lst = dir('patient*hdr'); 
for i=1:size(lst,1);
    info=analyze75info(lst(i).name); 
    PACIENTES(i,:,:,:) = analyze75read(info);
    pacientes_info (i,:) = lst(i).name (9:21);
end;

cd ..

%%Crystal brains
%resize_img ('female_twoGroups_0Covariates.hdr', [1.028 1.043 1.028]);

cd crystal_brains/

cd Female_smth10_TwoGroups/
info=analyze75info('oversampled_female_twoGroups_0Covariates.hdr'); 
crystal_brain_0cov=analyze75read(info);
cd ..

cd Female_smth10_TwoGroups_nWBV/
info=analyze75info('rFemale_smth10_TwoGroups_nWBV_results.hdr');
crystal_brain_nwbv=analyze75read(info);
cd ..

cd Female_smth10_TwoGroups_nWBV_Age/
info=analyze75info('rFemale_smth10_Age_nWBV_Results.hdr');
crystal_brain_age_nwbv=analyze75read(info);
cd ..

cd Female_smth10_TwoGroups_nWBV_Age_Educ/
info=analyze75info('rFemale_smth10_Age_nWBV_Educ_Results.hdr');
crystal_brain_educ_age_nwbv=analyze75read(info);
cd ..

%extraccion de caracteristicas
[L_0cov         , num_clusters_0cov          ] = bwlabeln (female_crystal_brain_0cov          );
[L_nwbv         , num_clusters_nwbv          ] = bwlabeln (female_crystal_brain_nwbv          );
[L_age_nwbv     , num_clusters_age_nwbv      ] = bwlabeln (female_crystal_brain_age_nwbv      );
[L_educ_age_nwbv, num_clusters_educ_age_nwbv ] = bwlabeln (female_crystal_brain_educ_age_nwbv );


%% option 1
%%===============================================================================
%media y desviacion estandar de las intensidades de los vóxeles de los sujetos dentro de cada cluster

function [C P] = extractMeanAndStdDevFromEachCluster (crystal_brain, num_clusters, controls, patients)

   mean_idx=1;
   std_idx =2;

   size_x = size(crystal_brain,1);
   size_y = size(crystal_brain,2);
   size_z = size(crystal_brain,3);

   %FOR OASIS original subjects
   for i = 1:size(controls,1); 
       subj = reshape (controls(i,:,:,:), size_x, size_y, size_z); 
       for k = 1:num_clusters; 
           C(i,k,mean_idx) = mean (double(subj(crystal_brain==k)));
           C(i,k, std_idx) = std  (double(subj(crystal_brain==k))); 
       end; 
   end;

   for i = 1:size(patients,1); 
       subj = reshape (patients(i,:,:,:), size_x, size_y, size_z);
       for k = 1:num_clusters; 
           P(i,k,mean_idx) = mean (double(subj(crystal_brain==k))); 
           P(i,k, std_idx) = std  (double(subj(crystal_brain==k))); 
       end;
   end;

%For OASIS subjects registered to SPM template (dimensions change)
for i = 1:size(CONTROLES,1); 
    subj = reshape (CONTROLES(i,:,:,:), 109, 91, 91); 
    for k = 1:num_clusters; 
        controles_chars(i,k,mean_idx) = mean (double(subj(L==k)));
        controles_chars(i,k,std_idx) = std (double(subj(L==k))); 
    end; 
end;

for i = 1:size(PACIENTES,1); 
    subj = reshape (PACIENTES(i,:,:,:), 109, 91, 91); 
    for k = 1:num_clusters; 
        pacientes_chars(i,k,mean_idx) = mean (double(subj(L==k))); 
        pacientes_chars(i,k,std_idx) = std (double(subj(L==k))); 
    end;
end;

%organizar datos
for i = 1:size(pacientes_chars,1); 
    subj_feat_inst (i,:) = reshape (pacientes_chars(i,:,:),1, num_clusters*2); 
    subj_feat_label(i) = -1;
end;

for i = (size(pacientes_chars,1)+1):(size(pacientes_chars,1)+size(controles_chars,1)); 
    subj_feat_inst (i,:) = reshape (controles_chars(i-size(controles_chars,1),:,:),1,num_clusters*2); 
    subj_feat_label(i) = 1;
end;

subj_feat_label = subj_feat_label';


%% option 2
%%===============================================================================
%proporción de WM, GM y CSF de cada sujeto dentro de cada cluster
csf_idx=1;
gm_idx=2;
wm_idx=3;

for k = 1:num_clusters; 
    cluster_size (k) = sum(sum(sum(L==k)));
end;

for i = 1:size(PACIENTES,1); 
    subj = reshape (PACIENTES(i,:,:,:), 208, 176, 176); 
    for k = 1:num_clusters; 
        pacientes_chars(i,k,csf_idx) = sum ( sum ( sum (double(subj(L==k)) == 1))) / cluster_size(k);
        pacientes_chars(i,k,gm_idx ) = sum ( sum ( sum (double(subj(L==k)) == 2))) / cluster_size(k);
        pacientes_chars(i,k,wm_idx ) = sum ( sum ( sum (double(subj(L==k)) == 3))) / cluster_size(k);
    end;
end;

for i = 1:size(CONTROLES,1); 
    subj = reshape (CONTROLES(i,:,:,:), 208, 176, 176); 
    for k = 1:num_clusters; 
        controles_chars(i,k,csf_idx) = sum ( sum ( sum (double(subj(L==k)) == 1))) / cluster_size(k);
        controles_chars(i,k,gm_idx ) = sum ( sum ( sum (double(subj(L==k)) == 2))) / cluster_size(k);
        controles_chars(i,k,wm_idx ) = sum ( sum ( sum (double(subj(L==k)) == 3))) / cluster_size(k);
    end; 
end;

%organizar datos
for i = 1:size(pacientes_chars,1); 
    subj_feat_inst (i,:) = reshape (pacientes_chars(i,:,:),1,36); 
    subj_feat_label(i) = -1;
end;

for i = (size(pacientes_chars,1)+1):(size(pacientes_chars,1)+size(controles_chars,1)); 
    subj_feat_inst (i,:) = reshape (controles_chars(i-size(controles_chars,1),:,:),1,36); 
    subj_feat_label(i) = 1;
end;

subj_feat_label = subj_feat_label';

%%option 3
%%===============================================================================
%% all GM voxel intensitities inside the crystal brain voxels, 
%% scaled and put as a vector

for i = 1:size(PACIENTES,1);
    subj = PACIENTES(i,:,:,:);
    for k = 1:num_clusters;
        pacientes_chars (i,:) = double(subj(L>0));
    end;
end;

for i = 1:size(CONTROLES,1); 
    subj = CONTROLES(i,:,:,:);
    for k = 1:num_clusters;
        controles_chars (i,:) = double(subj(L>0));
    end;
end;

%organizar datos
for i = 1:size(pacientes_chars,1); 
    subj_feat_inst (i,:) = double(pacientes_chars(i,:));
    subj_feat_label(i) = -1;
end;

for i = (size(pacientes_chars,1)+1):(size(pacientes_chars,1)+size(controles_chars,1)); 
    subj_feat_inst (i,:) = double(controles_chars(i-size(pacientes_chars,1),:,:));
    subj_feat_label(i) = 1;
end;

subj_feat_label = subj_feat_label';

clear pacientes_chars controles_chars

%%option 4
%%===============================================================================
%% ALL GM voxel intensitities from each subject 
%% scaled and put as a vector

for i = 1:size(PACIENTES,1);
    subj = PACIENTES(i,:,:,:);
    for k = 1:num_clusters;
        pacientes_chars (i,:) = double(subj(:));
    end;
end;

for i = 1:size(CONTROLES,1); 
    subj = CONTROLES(i,:,:,:);
    for k = 1:num_clusters;
        controles_chars (i,:) = double(subj(:));
    end;
end;

%organizar datos
for i = 1:size(pacientes_chars,1); 
    subj_feat_inst (i,:) = double(pacientes_chars(i,:));
    subj_feat_label(i) = -1;
end;

for i = (size(pacientes_chars,1)+1):(size(pacientes_chars,1)+size(controles_chars,1)); 
    subj_feat_inst (i,:) = double(controles_chars(i-size(controles_chars,1),:,:));
    subj_feat_label(i) = 1;
end;

subj_feat_label = subj_feat_label';

%% option 5
%%===============================================================================
%% GM matter proportion for each crystal brain cluster

for k = 1:num_clusters; 
    cluster_size (k) = sum(sum(sum(L==k)));
end;

for i = 1:size(PACIENTES,1); 
    subj = reshape (PACIENTES(i,:,:,:), 109, 91, 91); 
    for k = 1:num_clusters; 
        pacientes_chars(i,k) = sum ( sum ( sum (double(subj(L==k))))) / cluster_size(k);
    end;
end;

for i = 1:size(CONTROLES,1); 
    subj = reshape (CONTROLES(i,:,:,:), 109, 91, 91); 
    for k = 1:num_clusters; 
        controles_chars(i,k) = sum ( sum ( sum (double(subj(L==k))))) / cluster_size(k);
    end; 
end;

%organizar datos
for i = 1:size(pacientes_chars,1); 
    subj_feat_inst (i,:) = pacientes_chars(i,:);
    subj_feat_label(i) = -1;
end;

for i = (size(pacientes_chars,1)+1):(size(pacientes_chars,1)+size(controles_chars,1)); 
    subj_feat_inst (i,:) = controles_chars(i-size(controles_chars,1),:);
    subj_feat_label(i) = 1;
end;

subj_feat_label = subj_feat_label';

%%RESULTADOS EXPERIMENTOS:
%-------------------------------------------------------------------------------------------------------
%%%C-SVM RBF pacientes vs. controles - 0cov clusters GM intensity from SPM
%model = svmtrain (subj_feat_label, subj_feat_inst, '-g 0.0078125 -v 10');
%Cross Validation Accuracy = 76.5306%

%-------------------------------------------------------------------------------------------------------
%%%C-SVM linear pacientes vs. controles - 0cov clusters GM intensity from SPM
%model = svmtrain (subj_feat_label, subj_feat_inst, '-t 0 -v 10');
%Cross Validation Accuracy = 66.3265%

%-------------------------------------------------------------------------------------------------------
%%%C-SVM RBF pacientes vs. controles - nwbv clusters GM intensity from SPM
%L = L_nwbv;
%num_clusters = num_clusters_nwbv;
%model = svmtrain (subj_feat_label, subj_feat_inst, '-g 0.0078125 -v 10');
%Cross Validation Accuracy = 73.4694%


%-------------------------------------------------------------------------------------------------------
%%% ONE_CLASS SVM pacientes - 0cov clusters GM intensity from SPM

% Cross validation de pacientes
%model = svmtrain (subj_feat_label, subj_feat_inst, '-g 0.0078125 -s 2 -v 10');
%Cross Validation Accuracy = 81.6327%

%test_feat = pacientes
%model = svmtrain (subj_feat_label, subj_feat_inst, '-g 0.0078125 -s 2');
%[predict_label, accuracy, prob_estimates] = svmpredict(test_feat_label, test_feat_inst, model);
%Accuracy = 79.5918% (39/49) (classification)

%test_feat = controles + pacientes
%model = svmtrain (subj_feat_label, subj_feat_inst, '-g 0.0078125 -s 2');
%[predict_label, accuracy, prob_estimates] = svmpredict(test_feat_label, test_feat_inst, model);
%Accuracy = 67.3469% (66/98) (classification)

%%===============================================================================

%data scaling
for c=1:size(subj_feat_inst,2)
    feat_min(c) = min(subj_feat_inst(:,c));
    feat_max(c) = max(subj_feat_inst(:,c));
end

for s=1:size(subj_feat_inst,1)
    for c=1:size(subj_feat_inst,2)
        value = subj_feat_inst(s,c);
        % if not 0-1 scaling:
        % scaled_subj_feat_inst(s,c) = lower + (upper-lower) * (value-feature_min[index])/ (feature_max[index]-feature_min[index]);
        scaled_subj_feat_inst(s,c) = (value - feat_min(c)) / (feat_max(c)-feat_min(c));
    end
end


%SVM training
model = svmtrain (subj_feat_label, scaled_subj_feat_inst, '-g 0.0078125');

%prediction of training data
[predict_label, accuracy, prob_estimates] = svmpredict(subj_feat_label, scaled_subj_feat_inst, model);


%%===============================================================================
%leave-one-out validation
for s=1:size(scaled_subj_feat_inst,1); 
    idx=(1:size(scaled_subj_feat_inst,1)~=s); 
    train_inst=scaled_subj_feat_inst(idx==1,:); 
    train_label=subj_feat_label(idx==1); 
    model = svmtrain (train_label, train_inst, '-g 0.0078125'); 
    [predict_label, accuracy, prob_estimates] = svmpredict(subj_feat_label(s), scaled_subj_feat_inst(s,:), model); 
    scaled_loo_results(s).predict_label = predict_label; 
    scaled_loo_results(s).accuracy=accuracy; 
    scaled_loo_results(s).prob_estimates=prob_estimates; 
end;
aux=0;for i=1:size(scaled_loo_results,2); aux=aux+scaled_loo_results(i).accuracy(1); end; scaled_total=aux/size(scaled_loo_results,2)

%%leave-one-out NOT SCALED
for s=1:size(subj_feat_inst,1); 
    idx=(1:size(subj_feat_inst,1)~=s); 
    train_inst=subj_feat_inst(idx==1,:); 
    train_label=subj_feat_label(idx==1); 
    model = svmtrain (train_label, train_inst, '-g 0.0078125'); 
    [predict_label, accuracy, prob_estimates] = svmpredict(subj_feat_label(s), subj_feat_inst(s,:), model); 
    loo_results(s).predict_label = predict_label; 
    loo_results(s).accuracy=accuracy; 
    loo_results(s).prob_estimates=prob_estimates; 
end;
aux=0;for i=1:size(loo_results,2); aux=aux+loo_results(i).accuracy(1); end; total=aux/size(loo_results,2)

%%===============================================================================

%%wrong k-fold testing
%10-fold testing
idx = [(1:5);(2:6);(3:7);(4:8);(5:9);(6:10);(7:11);(8:12);(9:13);(10:14);(11:15);(12:16);(13:17);(14:18);(15:19);(16:20);(17:21);(18:22);(19:23);(20:24);(21:25);(22:26);(23:27);(24:28);(25:29);(26:30);(27:31);(28:32);(29:33);(30:34);(31:35);(32:36);(33:37);(34:38);(35:39);(36:40);(37:41);(38:42);(39:43);(40:44);(41:45);(42:46);(43:47);(44:48);(45:49)];

%4-fold testing
idx = [(1:2);(2:3);(3:4);(4:5);(5:6);(6:7);(7:8);(8:9);(9:10);(10:11);(11:12);(12:13);(13:14);(14:15);(15:16);(16:17);(17:18);(18:19);(19:20);(20:21);(21:22);(22:23);(23:24);(24:25);(25:26);(26:27);(27:28);(28:29);(29:30);(30:31);(31:32);(32:33);(33:34);(34:35);(35:36);(36:37);(37:38);(38:39);(39:40);(40:41);(41:42);(42:43);(43:44);(44:45);(45:46);(46:47);(47:48);(48:49)]; 

n_subj=49;

for f=1:size(idx,1)
   test_feats   = vertcat (scaled_subj_feat_inst (idx(f,:),:), scaled_subj_feat_inst (idx(f,:)+n_subj,:));
   test_labels  = vertcat (subj_feat_label       (idx(f,:),:), subj_feat_label       (idx(f,:)+n_subj,:));

   not_idx=0; rng=(1:98); 
   for i=1:size(idx(f,:),2); not_idx=(rng~=idx(f,i))-(not_idx==0); end;
   for i=1:size(idx(f,:),2); not_idx=(rng~=idx(f,i)+n_subj)-(not_idx==0); end;
   not_idx=~not_idx;

   train_feats  = vertcat (scaled_subj_feat_inst (not_idx,:));
   train_labels = vertcat (subj_feat_label       (not_idx,:));

   model = svmtrain (train_labels, train_feats, '-g 3.05176e-05');
   [predict_label, accuracy, prob_estimates] = svmpredict(test_labels, test_feats, model);
   kfold_result(f).predict_label = predict_label;
   kfold_result(f).accuracy=accuracy; 
   kfold_result(f).prob_estimates=prob_estimates; 
end
   
aux=0;for i=1:size(kfold_result,2); aux=aux+kfold_result(i).accuracy(1); end; total=aux/size(kfold_result,2)


%%===============================================================================
% write data to txt file in libsvm format
fid = fopen('datos_mri.txt','w');
for i=1:size(subj_feat_inst,1);
    fprintf (fid, '%d ',subj_feat_label(i));
    for c=1:size(subj_feat_inst,2);
        fprintf (fid, '%d:%f ', c, subj_feat_inst(i,c));
    end;
    fprintf(fid,'\n');
end;
status = fclose(fid);

%%===============================================================================
%% FAIL COUNTER
fail_counter = zeros(1,size(predict_label,1))';
for i=1:size(predict_label,1); if (predict_label(i) ~= label(i)) fail_counter(i,:) = fail_counter(i,:) + 1; end; end;

%%===============================================================================
%% barrido en gamma
gamma=0;for i=1:100000;gamma=gamma+0.00001;accuracy = svmtrain (label, data, sprintf ('-v 10 -g %f', gamma));gamma_test(i,:) = [gamma, accuracy];end;plot (gamma_test(:,1), gamma_test(:,2));

%%===============================================================================
%% concatenar todas las intensidades de vóxeles de los clusters en una matriz, 
%% fila por cada sujeto
for s=1:size(voxels_data,1);
   for c=1:2:size(voxels_data,2); 
      kk=horzcat(voxels_data(s,c).voxels', voxels_data(s,c+1).voxels'); 
      if (c~=1); aux=horzcat(kk,aux); 
      else;      aux=kk; 
      end;
   end;
   voxels_matrix(s,:) = aux; 
   clear aux kk; 
end;

%%===============================================================================
%% SVM voting
cd /media/xcraft/Documents/phd/medical_images/my_papers/IWANN09/src

load ../Female/spm/spm_segmented_oasis_females.mat

[C P] = extractMeanAndStdDevFromEachCluster (female_crystal_brain_cov0, CONTROLES, PACIENTES);

[L, num_clusters] = bwlabeln (female_crystal_brain_cov0);

k_de_kfold = 10;
p = cvpartition(size(C,1),'kfold',k_de_kfold);
total_tests = 0;
TP = 0;
TN = 0;
FP = 0;
FN = 0;

for k=1:k_de_kfold;

   C_training = C(training (p,k) == 1,:,:);
   P_training = P(training (p,k) == 1,:,:);
   C_test     = C(training (p,k) == 0,:,:);
   P_test     = P(training (p,k) == 0,:,:);
   total_results (k) = 0;

   for i=1:num_clusters;
      %training
      [training_data(i).data training_data(i).label] = alignAndLabelData (C_training(:,i ,:), P_training(:,i ,:));
      models(i) = svmtrain (training_data(i).label, training_data(i).data, '-s 2 -t 0'); %'-t 2 -g 0.031');

      %classification
      [test_data(i).data test_data(i).label] = alignAndLabelData (C_test(:,i ,:), P_test(:,i ,:));
      [results(k,i).predict_label results(k,i).accuracy results(k,i).prob_estimates] = svmpredict (test_data(i).label, test_data(i).data, models(i));
   end;

   for s=1:size(test_data(1).data,1);

      %voting from sum of all the results of each cluster SVM, 
      %if negative: class = -1
      %else if positive: class = 1
      %else if zero: only first cluster SVM prediction will be taken into account
      class = 0;
      for c=1:num_clusters;
         class = class + results (k,c).predict_label(s)*(1/c);
      end;
      if (class == 0);
         class = results (k,1).predict_label(s);
      end;

      sum_class = class
      subj_predictions(s) = sign(class)

      %counting and compare with target label
      target_label = test_data(1).label(s)

      if (test_data(1).label(s) == -1); %positive
         if   (subj_predictions(s) == -1); TP = TP + 1;
         else                              FN = FN + 1;
         end;
      else %negative
         if   (subj_predictions(s) ==  1); TN = TN + 1;
         else                              FP = FP + 1;
         end;
      end;

      total_tests = total_tests + 1;

   end;

%   predictions(k,:) = subj_predictions(:);

   clear subj_predictions;

end;
Accuracy    = (TP + TN) / total_tests
Specificity = TN / (TN+FP)
Sensitivity = TP / (TP+FN)

%%===============================================================================
%%Mean and StdDev SVMVoting

Times = 10;

Sum_Accuracy    = 0;
Sum_Specificity = 0;
Sum_Sensitivity = 0;

for times=1:Times;
   [Accuracy Specificity Sensitivity] = SVM_MeanAndStdDev ();
   Sum_Accuracy    = Sum_Accuracy    + Accuracy;
   Sum_Specificity = Sum_Specificity + Specificity;
   Sum_Sensitivity = Sum_Sensitivity + Sensitivity;
end;

Mean_Accuracy    = Sum_Accuracy    /Times
Mean_Specificity = Sum_Specificity /Times
Mean_Sensitivity = Sum_Sensitivity /Times

%%===============================================================================
%%Mean and StdDev SVMVoting

Times = 10;

Sum_Accuracy    = 0;
Sum_Specificity = 0;
Sum_Sensitivity = 0;

for times=1:Times;
   [Accuracy Specificity Sensitivity] = SVMVoting_MeanAndStdDev ();
   Sum_Accuracy    = Sum_Accuracy    + Accuracy;
   Sum_Specificity = Sum_Specificity + Specificity;
   Sum_Sensitivity = Sum_Sensitivity + Sensitivity;
end;

Mean_Accuracy    = Sum_Accuracy    /Times
Mean_Specificity = Sum_Specificity /Times
Mean_Sensitivity = Sum_Sensitivity /Times

%%===============================================================================
%%Voxel Intensities SVMVoting
Times = 10;

Sum_Accuracy    = 0;
Sum_Specificity = 0;
Sum_Sensitivity = 0;

for times=1:Times;
   [Accuracy Specificity Sensitivity] = SVMVoting_VoxelIntensities ()
   Sum_Accuracy    = Sum_Accuracy    + Accuracy;
   Sum_Specificity = Sum_Specificity + Specificity;
   Sum_Sensitivity = Sum_Sensitivity + Sensitivity;
end;

Mean_Accuracy    = Sum_Accuracy    /Times
Mean_Specificity = Sum_Specificity /Times
Mean_Sensitivity = Sum_Sensitivity /Times

%%===============================================================================
%%ClusterSVM Mean and StdDev AdaBoost
Times = 10;

Sum_Accuracy    = 0;
Sum_Specificity = 0;
Sum_Sensitivity = 0;

for times=1:Times;
   [Accuracy Specificity Sensitivity] = ClusterSVM_AdaBoost ()
   Sum_Accuracy    = Sum_Accuracy    + Accuracy;
   Sum_Specificity = Sum_Specificity + Specificity;
   Sum_Sensitivity = Sum_Sensitivity + Sensitivity;
end;

Mean_Accuracy    = Sum_Accuracy    /Times
Mean_Specificity = Sum_Specificity /Times
Mean_Sensitivity = Sum_Sensitivity /Times


%%===============================================================================
%%ClusterSVM Voxel Intensities AdaBoost
Times = 10;

Sum_Accuracy    = 0;
Sum_Specificity = 0;
Sum_Sensitivity = 0;

for times=1:Times;
   [Accuracy Specificity Sensitivity] = ClusterSVM_AdaBoost_VoxelIntensities ()
   Sum_Accuracy    = Sum_Accuracy    + Accuracy;
   Sum_Specificity = Sum_Specificity + Specificity;
   Sum_Sensitivity = Sum_Sensitivity + Sensitivity;
end;

Mean_Accuracy    = Sum_Accuracy    /Times
Mean_Specificity = Sum_Specificity /Times
Mean_Sensitivity = Sum_Sensitivity /Times

%%===============================================================================
%%Diverse AdaBoostSVM
Times = 10;

Sum_Accuracy    = 0;
Sum_Specificity = 0;
Sum_Sensitivity = 0;

for times=1:Times;
   [Accuracy Specificity Sensitivity] = Diverse_AdaBoostSVM ()
   Sum_Accuracy    = Sum_Accuracy    + Accuracy;
   Sum_Specificity = Sum_Specificity + Specificity;
   Sum_Sensitivity = Sum_Sensitivity + Sensitivity;
end;

Mean_Accuracy    = Sum_Accuracy    /Times
Mean_Specificity = Sum_Specificity /Times
Mean_Sensitivity = Sum_Sensitivity /Times


